**********************************************************************
* FILE NOTE:
* Original version from early 2018 code, created 2018/1/26
* This updated version from the file bbl_2017_analysis_v1_clean, emailed 2018-03-18 [dated 26 Feb 2018]
**********************************************************************

*_____________________________________________________________________________________________________________________________________________________
*
* Getting this to work on BBG computer
*_____________________________________________________________________________________________________________________________________________________

// Setting the overall file locations
do "C:\Users\bpb\Dropbox\Disability work\ESRC Future Leaders Disability\Phase 1 (Dis Emp Rates) - Intl\ELSA-SHARE-HRS\0_master.do"
global boheimleoni_latestdo		"${dodir}\Boheim-Leoni reference files\2018-05-10\Latest do files"
global boheimleoni_graphs		"${dodir}\Boheim-Leoni reference files\z. Latest charts"
* Used in the multiple imputation .do file
global inputDir 			"${hrsdir}"
global outputDir 			"${hrsdir}"
global graphDir				"${boheimleoni_graphs}\0. MI charts"
global graphtmpDir 			"${boheimleoni_graphs}\0. MI charts"
global tempDir 				"${boheimleoni_graphs}\0. MI charts"


// Other things that are needed
capture which mdesc					// Thomas & Rene's cleaning relies on this command
	if _rc~=0		net install mdesc, from(http://fmwww.bc.edu/RePEc/bocode/m)
capture which ciplot				// Thomas & Rene's analysis relies on this command
	if _rc~=0		net install ciplot, from(http://fmwww.bc.edu/RePEc/bocode/c)
exit


*_____________________________________________________________________________________________________________________________________________________
*
* Running Thomas' data cleaning & analysis
*_____________________________________________________________________________________________________________________________________________________


// Boheim-Leoni data cleaning
use "${hrsdir}\BoheimLeoniGeiger_${versno}.dta", replace
pause This is a slow file (maybe half an hour)
do "${boheimleoni_latestdo}\1.bbl_2017_pca_BBG.do"						
	/* This does the following:
		Files it produces:
			"${hrsdir}\v3_6_boheimleoniPCA.dta"	- includes the PCA scores (pca_cntr c_pvw100 pca_cntr_nbmi c_pvw100_nbmi)
				Also includes some cleaned variables (see below): age ret_age sphus45, as well as mergeid country wave survey
				(Thomas filename for this is "$outputDir\bbl_health_SHAREHRSELSA.dta"
		Does PCA - and other data cleaning (dropping existing versions if already there):
			sphus45
			ragey renamed to rage
			recodes rbmicat into underw and obese 
			keeping only relevant countries
			country2
			country_waveN
			wave_tmp - wave numbered 1-6
		Other checking done
			Looking at missing data using MDESC
	*/
// The following file starts, use "${hrsdir}\BoheimLeoniGeiger_v3_6.dta", clear
do "${boheimleoni_latestdo}\2.bbl_2017_analysis_BBG.do"						
	* Tidying up
	graph close _all
	cd "${boheimleoni_latestdo}"
	local deleteme: dir . files "*.gph"
	foreach file in `deleteme' {
		erase "`file'"
	/**/ }
	/* This does the following:
		Files it produces:
			"${hrsdir}\${versno}_boheimleonianalysis"
			(Thomas filename for this is "$inputDir\bbl_2017_analysis_beta.dta")
		Data cleaning done:
			merges in PCA
			keeping only relevant countries
			country2
			country_waveN
			wave_tmp - wave numbered 1-6
			injob (for rworknew), labour force statuses (lbrf_new that priorities injob, but also retired unemp home disab empl)
			continuous employmet (based on tenure)
			other things - agesq, pensionage (if >ret_age) and natage
			(Also creates future vars - lfsw1-3 (future lbrf), w[1-3]injob w[1-2]unemp w[1-2]retired w[1-2]pensionage w[1-2]_pvw100 (future versions of all vars)
			carryforward missing - for gender in ELSA 
*/
use "${hrsdir}\\${versno}_boheimleonianalysis", replace

